# Tracker.jl

[![Build Status](https://github.com/FluxML/Tracker.jl/actions/workflows/CI.yml/badge.svg?branch=master)](https://github.com/FluxML/Tracker.jl/actions/workflows/CI.yml?query=branch%3Amaster)
[![Coverage](https://codecov.io/gh/FluxML/Tracker.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/FluxML/Tracker.jl)
<!---[![Coverage](https://coveralls.io/repos/github/FluxML/Tracker.jl/badge.svg?branch=master)](https://coveralls.io/github/FluxML/Tracker.jl?branch=master) --->
[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac)


This was the original automatic differentiation engine for [Flux.jl](https://github.com/FluxML/Flux.jl), before being replaced by [Zygote.jl](https://github.com/FluxML/Zygote.jl) in 2019. Both were written by Mike Innes.

This package is solid and still in active use, but is no longer heavily maintained. PRs and issues may go unanswered.

### Introduction

Like [ReverseDiff.jl](https://github.com/JuliaDiff/ReverseDiff.jl) and [AutoGrad.jl](https://github.com/denizyuret/AutoGrad.jl), Tracker traces through a program by wrapping arrays in a special `TrackedArray` type. The final answer contains a "tape" of the operations performed, which is reversed by `back!`:

```julia
x = param([1,2,3])  # Tracked 3-element Vector{Float64}

f(x) = sum(abs2, x) + prod(x[2:end])

y = f(x)  # TrackedReal

back!(y)  # run back-propagation

Tracker.grad(x)  # extract gradient from TrackedArray
```

This is a much lower-tech approach than that of [Zygote](https://github.com/FluxML/Zygote.jl), [Yota](https://github.com/dfdx/Yota.jl) and [Diffractor](https://github.com/JuliaDiff/Diffractor.jl). At best, those can produce fast, compiled Julia code for the reverse pass, instead of an interpreted tape. At worst, they can have extremely long compile-times and can be difficult to debug.

### Interface

Instead of calling `back!` yourself, you can pass the function and the input to `gradient`:

```julia
gradient(f, [1,2,3])  # returns ([2.0, 7.0, 8.0],)

withgradient(f, [1,2,3])  # returns (val = 20, grad = ([2.0, 7.0, 8.0],))
```

The original interface to [Flux.jl](https://github.com/FluxML/Flux.jl) involved a dictionary of arrays called `Params`, much like Zygote's "implicit" parameter interface. This appears not to be documented.

A more modern way to use Flux relies on `withgradient`'s ability to take gradients with respect to complex nested structures. This is what [Optimisers.jl](https://github.com/FluxML/Optimisers.jl) is designed to accept:

```julia
julia> using Flux, Tracker

julia> model = Chain(Dense(2 => 1, tanh), Dense(1 => 1, bias=false));

julia> withgradient(model, rand(Float32, 2)) do m, x
         sum(abs2, m(x))
       end
(val = 0.035716165f0, 
 grad = ((layers = ((weight = Float32[-0.4241869 -0.16741231], bias = Float32[-0.5529184], σ = nothing), 
                    (weight = Float32[-0.04804218;;], bias = nothing, σ = nothing)),), 
         Float32[0.12706584, -0.08858479]))
```

### Rules

Tracker.jl contains rules for many common operations. It relies on [DiffRules.jl](https://github.com/JuliaDiff/DiffRules.jl) for many definitions, and does not connect to the newer [ChainRules.jl](https://github.com/JuliaDiff/ChainRules.jl) at all.

To define more rules, use `track` and `@grad`. See the source for more examples:

```julia
f(x::TrackedArray) = track(f, x)    # entry point, via dispatch

@grad function f(x)
  y = f(data(x))                    # forward pass, withtout tracking
  back(dy) = (dy * ∂f∂x(data(x)),)  # pullback function, returns a tuple
  return y, back
end
```

import LogExpFunctions

@testset "LogExpFunctions" begin
    x = 0.4
    @test gradient(LogExpFunctions.logit, x)[1] ≈ inv(x * (1 - x))

    x = 0.2
    @test gradient(LogExpFunctions.log1pmx, x)[1] ≈ -x / (1 + x)

    x = -0.3
    @test gradient(LogExpFunctions.log2mexp, x)[1] ≈ -exp(x) / (2 - exp(x))

    x, y = 0.2, -0.4
    ∂x, ∂y = gradient(LogExpFunctions.logaddexp, x, y)
    denominator = exp(x) + exp(y)
    @test ∂x ≈ exp(x) / denominator
    @test ∂y ≈ exp(y) / denominator
end

module TrackerPDMatsExt

if !isdefined(Base, :get_extension)
    using ..Tracker, ..PDMats
else
    using Tracker, PDMats
end

Base.:\(A::PDMat, B::Tracker.TrackedVecOrMat) = Tracker.track(\, A, B)
Base.:\(A::PDiagMat, B::Tracker.TrackedVecOrMat) = Tracker.track(\, A, B)
Base.:\(A::ScalMat, B::Tracker.TrackedVecOrMat) = Tracker.track(\, A, B)

end

# The AD generates fairly large backtraces that are unhelpful if you interrupt
# while training; this just cleans that up.
macro interrupts(ex)
  :(try $(esc(ex))
    catch e
      e isa InterruptException || rethrow()
      throw(e)
    end)
end

# In-place gradients

init_grad(x) = zero(x)
zero_grad!(x) = zero(x)
zero_grad!(x::AbstractArray) = (x .= 0)

scan(c::Call) = foreach(scan, c.args)

function scan(x::Tracked)
  x.isleaf && return
  ref = x.ref += 1
  if ref == 1
    scan(x.f)
    isdefined(x, :grad) && (x.grad = zero_grad!(x.grad))
  end
  return
end

function scan(x)
  istracked(x) && scan(tracker(x))
  return
end

function back_(c::Call, Δ, once)
  Δs = c.func(Δ)
  (Δs isa Tuple && length(Δs) >= length(c.args)) ||
    error("Gradient is not a tuple of length $(length(c.args))")
  foreach((x, d) -> back(x, d, once), c.args, data.(Δs))
end

back_(::Call{Nothing}, Δ, once) = nothing
back_(::Call{Missing}, Δ, once) = error("`back!` was already used")

accum!(x, Δ) = x .+ Δ
accum!(x::AbstractArray, Δ) = (x .+= Δ)

function back(x::Tracked, Δ, once)
  x.isleaf && (x.grad = accum!(x.grad, Δ); return)
  ref = x.ref -= 1
  grad = if isdefined(x, :grad)
    x.grad = accum!(x.grad, Δ)
  elseif ref > 0
    x.grad = Δ
  else
    Δ
  end
  if ref == 0
    back_(x.f, grad, once)
    once && !x.isleaf && (x.f = Call(missing, ()))
  end
  return
end

back(::Nothing, Δ, once) = return

# Interface methods

# TODO: if an error occurs in `back` the refcounts will be broken
# and `back` will silently fail to update.
# (but only if you re-use intermediate values between passes)
# Refcounts are also probably not safe in some situations (e.g. back called
# from within a backpropagator)

function back!(x, Δ; once = true)
  istracked(x) || return
  scan(x)
  back(tracker(x), Δ, once)
  return
end

function extract_grad!(x)
  x̄ = copy(grad(x))
  x̄ = nobacksies("Use `gradient(...; nest = true)` for nested derivatives", x̄)
  tracker(x).grad = zero_grad!(grad(x))
  return x̄
end

function gradient_(f, xs...)
  xs = param.(data.(xs))
  l = f(xs...)
  losscheck(l)
  @interrupts back!(l)
  extract_grad!.(xs)
end

function gradient_(f, xs::Params)
  l = f()
  losscheck(l)
  @interrupts back!(l)
  gs = Grads()
  for x in xs
    gs[tracker(x)] = extract_grad!(x)
  end
  return gs
end

# Out-of-place gradients

function back_(g::Grads, c::Call, Δ)
  Δs = c.func(Δ)
  (Δs isa Tuple && length(Δs) >= length(c.args)) ||
    error("Gradient is not a tuple of length $(length(c.args))")
  foreach((x, Δ) -> back(g, x, Δ), c.args, Δs)
end

back_(g::Grads, ::Call{Nothing}, Δ) = nothing

function back(g::Grads, x::Tracked, Δ)
  x.isleaf && (accum!(g, x, Δ); return)
  ref = x.ref -= 1
  if ref > 0 || haskey(g, x)
    accum!(g, x, Δ)
    ref == 0 && back_(g, x.f, g[x])
  else
    ref == 0 && back_(g, x.f, Δ)
  end
  return
end

back(::Grads, ::Nothing, _) = return

collectmemaybe(xs) = xs

function forward(f, ps::Params)
  y = collectmemaybe(f())
  y, function (Δ)
    g = Grads(ps)
    if istracked(y)
      scan(y)
      back(g, tracker(y), Δ)
    end
    return g
  end
end

function forward(f, args...)
  args = param.(args)
  y, back = forward(() -> f(args...), Params(args))
  y, Δ -> getindex.(Ref(back(Δ)), args)
end

function losscheck(x)
  x isa Real || error("Function output is not scalar")
  isinf(x) && error("Loss is infinite")
  isnan(x) && error("Loss is NaN")
end

function gradient_nested(f, args...)
  y, back = forward(f, args...)
  losscheck(y)
  return back(1)
end

gradient(f, xs...; nest = false) =
  nest ? gradient_nested(f, xs...) : gradient_(f, xs...)

# Jacobians and Hessians

"""
    J = jacobian(m,x)

Calculate the output jacobian `J = d/dx m(x)` such that each row `i` of `J` corresponds to the gradient `J[i,:] = ∇ₓ(m(x)[i])`
"""
function jacobian(f, x::AbstractVector)
  y::AbstractVector, back = forward(f, x)
  ȳ(i) = [i == j for j = 1:length(y)]
  vcat([transpose(back(ȳ(i))[1]) for i = 1:length(y)]...)
end

hessian(f, x) = jacobian(x -> gradient(f, x, nest=true)[1], x)

using Functors: fmap, functor
using Optimisers: _trainable, isnumeric

"""
    withgradient(f, xs...)

This computes the value `f(xs...)` and the gradient with respect to `xs`.
However, it differs from `gradient` in several other respects:
* It will recurse into `xs` using `fmap`, and thus like Zygote's "explicit mode" it
  returns a tree-like gradient matching the shape of a Flux model.
  This recursion obeys restrictions imposed by `Optimisers.trainable`, if defined.
* Only objects satisfying `Optimisers.isnumeric` are regarded as parameters,
  thus in particular arrays of integers are ignored.
* Returns plain arrays, not tracked. Uses `nothing` as a strong zero gradient, like Zygote.
* Allows you to capture auxillary outputs, in addition to the scalar
  used by `gradient`. To do this, `f` must return a Tuple or NamedTuple.
  Then it calculates `grad = gradient(first∘f, args...)
  but returns the whole `val = f(args...)`:

# Examples

```
julia> nt = (vec = [1.0, 2.0], mat = [4.0;;], fun = sin);

julia> withgradient(nt, 2) do x, p
         sum(abs2, x.vec) ^ p
       end
(val = 25.0, grad = ((vec = [20.0, 40.0], mat = [0.0;;], fun = nothing), nothing))

julia> using Flux

julia> model = Chain(Dense(2 => 1, tanh), Dense(1 => 1, bias=false));

julia> withgradient(model, rand(Float32, 2)) do m, x
         sum(abs2, m(x))
       end
(val = 0.035716165f0, grad = ((layers = ((weight = Float32[-0.4241869 -0.16741231], bias = Float32[-0.5529184], σ = nothing), (weight = Float32[-0.04804218;;], bias = nothing, σ = nothing)),), Float32[0.12706584, -0.08858479]))
```
"""
function withgradient(f, xs...)
    pxs = fmap(param, xs; exclude = isnumeric, walk = _trainable_walk)
    l = f(pxs...)
    l1 = l isa Union{Tuple, NamedTuple} ? first(l) : l
    val = l isa Union{Tuple, NamedTuple} ? fmap(data, l) : data(l)
    losscheck(l1)
    l1 isa TrackedReal || return (; val, grad = map(_ -> nothing, xs))
    @interrupts back!(l1)
    (; val, grad = rec_grad(pxs))
end

function _trainable_walk(f, x)
  func, re = functor(x)
  isempty(func) && return x
  done = map(f, _trainable(x))  # recurse only into trainable fields, this contains `nothing` elsewhere
  map(func, merge(func, done)) do n, t
      isnothing(t) ? n : t
  end |> re  # reconstruct the whole thing
end
_trainable_walk(f, x::Tuple) = map(f, x)

# Easier to write the recursion to extract the gradients without using fmap:
rec_grad(x::TrackedArray) = grad(x)
rec_grad(x::TrackedReal) = grad(x)
rec_grad(x::AbstractArray{<:Number}) = nothing
rec_grad(x::Number) = nothing

rec_grad(x::Union{Tuple,NamedTuple,AbstractArray}) = map(rec_grad, x)
rec_grad(::Tuple{}) = nothing
rec_grad(::NamedTuple{(), Tuple{}}) = nothing
function rec_grad(x::T) where {T}
    F = fieldnames(T)
    isempty(F) && return nothing
    map(f -> rec_grad(getfield(x, f)), NamedTuple{F}(F))
end

mutable struct TrackedReal{T<:Real} <: Real
  data::T
  tracker::Tracked{T}
end

TrackedReal(x::Real) = TrackedReal(x, Tracked{typeof(x)}(Call(), zero(x)))

data(x::TrackedReal) = x.data
tracker(x::TrackedReal) = x.tracker

ForwardDiff.value(x::TrackedReal) = x.data

track(f::Call, x::Real) = TrackedReal(x, Tracked{typeof(x)}(f, zero(x)))

function back!(x::TrackedReal; once = true)
    isinf(x) && error("Loss is Inf")
    isnan(x) && error("Loss is NaN")
    return back!(x, 1, once = once)
end

function update!(x::TrackedReal, Δ)
  x.data += data(Δ)
  tracker(x).grad = 0
  return x
end

function Base.show(io::IO, x::TrackedReal)
  T = get(io, :typeinfo, Any)
  show(io, data(x))
  T <: TrackedReal || print(io, " (tracked)")
end

Base.decompose(x::TrackedReal) = Base.decompose(data(x))

Base.copy(x::TrackedReal) = x

Base.convert(::Type{TrackedReal{T}}, x::TrackedReal{T}) where T = x

Base.convert(::Type{TrackedReal{T}}, x::Real) where T = TrackedReal(convert(T, x))

Base.convert(::Type{TrackedReal{T}}, x::TrackedReal{S}) where {T,S} =
  error("Not implemented: convert tracked $S to tracked $T")

(T::Type{<:TrackedReal})(x::Real) = convert(T, x)

for op in [:(==), :≈, :<, :(<=)]
  @eval Base.$op(x::TrackedReal, y::Real) = Base.$op(data(x), y)
  @eval Base.$op(x::Real, y::TrackedReal) = Base.$op(x, data(y))
  @eval Base.$op(x::TrackedReal, y::TrackedReal) = Base.$op(data(x), data(y))
end

Base.eps(x::TrackedReal) = eps(data(x))
Base.eps(::Type{TrackedReal{T}}) where T = eps(T)

for f in :[isinf, isnan, isfinite].args
  @eval Base.$f(x::TrackedReal) = Base.$f(data(x))
end

Printf.fix_dec(x::TrackedReal, n::Int, a...) = Printf.fix_dec(data(x), n, a...)
Printf.tofloat(x::TrackedReal) = Printf.tofloat(data(x))

Base.float(x::TrackedReal) = x

Base.promote_rule(::Type{TrackedReal{S}},::Type{T}) where {S,T} =
  TrackedReal{promote_type(S,T)}

using Random

for f in :[rand, randn, randexp].args
  @eval Random.$f(rng::AbstractRNG,::Type{TrackedReal{T}}) where {T} = param(Random.$f(rng,T))
end

for (M, f, arity) in DiffRules.diffrules(; filter_modules=nothing)
  if !(isdefined(@__MODULE__, M) && isdefined(getfield(@__MODULE__, M), f))
    @warn "$M.$f is not available and hence rule for it can not be defined"
    continue  # Skip rules for methods not defined in the current scope
  end
  Mf = :($M.$f)
  if arity == 1
    @eval begin
      @grad $Mf(a::Real) = $Mf(data(a)), Δ -> (Δ * $(DiffRules.diffrule(M, f, :a)),)
      $Mf(a::TrackedReal) = track($Mf, a)
    end
  elseif arity == 2
    da, db = DiffRules.diffrule(M, f, :a, :b)
    @eval begin
      @grad $Mf(a::TrackedReal, b::TrackedReal) = $Mf(data(a), data(b)), Δ -> (Δ * $da, Δ * $db)
      @grad $Mf(a::TrackedReal, b::Real) = $Mf(data(a), b), Δ -> (Δ * $da, zero(b))
      @grad $Mf(a::Real, b::TrackedReal) = $Mf(a, data(b)), Δ -> (zero(a), Δ * $db)
      $Mf(a::TrackedReal, b::TrackedReal)  = track($Mf, a, b)
      $Mf(a::TrackedReal, b::Real) = track($Mf, a, b)
      $Mf(a::Real, b::TrackedReal) = track($Mf, a, b)
    end
  end
end

# Eliminating ambiguity
import Base:^

^(a::TrackedReal, b::Integer) = track(^, a, b)

# Tuples

struct TrackedTuple{T<:Tuple}
  data::T
  tracker::Tracked{T}
end

data(xs::TrackedTuple) = xs.data
tracker(xs::TrackedTuple) = xs.tracker

accum!(x::Tuple, Δ::Tuple) = accum!.(x, Δ)
init_grad(x::Tuple) = init_grad.(x)
zero_grad!(x::Tuple) = zero_grad!.(x)

track(f::Call, xs::Tuple) = TrackedTuple(xs, Tracked{typeof(xs)}(f, zero.(xs)))

function Base.show(io::IO, xs::TrackedTuple)
  show(io, data(xs))
  print(io, " (tracked)")
end

Base.length(x::TrackedTuple) = length(data(x))

Base.getindex(xs::TrackedTuple, i::Integer) = track(getindex, xs, i)

@grad function getindex(xs::TrackedTuple, i)
  data(xs)[i], Δ -> (ntuple(j -> i == j ? Δ : 0, length(xs)), nothing)
end

# Array collection

function collect(xs)
  xs = Base.collect(xs)
  track(Call(collect, (tracker.(xs),)), data.(xs))
end

function scan(c::Call{typeof(collect)})
  foreach(scan, c.args[1])
end

function back_(c::Call{typeof(collect)}, Δ, once)
  foreach((x, d) -> back(x, d, once), c.args[1], data(Δ))
end

function back_(g::Grads, c::Call{typeof(collect)}, Δ)
  foreach((x, Δ) -> back(g, x, Δ), c.args[1], Δ)
end

collectmemaybe(xs::AbstractArray{>:TrackedReal}) = collect(xs)
collectmemaybe(xs::AbstractArray{<:TrackedReal}) = collect(xs)

# `logabsgamma` returns a tuple and hence its derivative is not defined in DiffRules
SpecialFunctions.logabsgamma(x::TrackedReal) = track(SpecialFunctions.logabsgamma, x)
@grad function SpecialFunctions.logabsgamma(x::Real)
  data_x = data(x)
  function logabsgamma_pullback(Δ)
    return (SpecialFunctions.digamma(data_x) * first(Δ),)
  end
  return SpecialFunctions.logabsgamma(data_x), logabsgamma_pullback
end

using Tracker, Test, Random, Statistics

Random.seed!(0)

@testset "Tracker" begin

include("tracker.jl")
include("chainrules.jl")

using Tracker: jacobian

@testset "Jacobian" begin
  A = param(randn(2,2))
  x = randn(2)
  m(x) = A*x
  y = m(x)
  J = jacobian(m,x)
  @test J ≈ A.data
end

using Optimisers, Functors
struct TwoThirds a; b; c; end  # evil test from Optimisers.jl
@eval Functors.@functor TwoThirds (a, c)
Optimisers.trainable(x::TwoThirds) = (a = x.a,)

@testset "withgradient" begin
  nt = (vec = [1.0, 2.0], mat = [4.0;;], fun = sin);
  @test withgradient((x, p) -> sum(abs2, x.vec) ^ p, nt, 2) == (val = 25.0, grad = ((vec = [20.0, 40.0], mat = [0.0;;], fun = nothing), nothing))

  @test withgradient(x -> sum(x.v), (v = [1, 2], w = [3.0])) == (val = 3, grad = (nothing,))
  @test withgradient(x -> (sum(x.v), x.v), (v = [1, 2], w = [3.0])) == (val = (3, [1, 2]),
    grad = (nothing,))
  @test withgradient(x -> (sum=sum(x.v), aux=33), (v = [1, 2], w = [3.0])) ==
    (val = (sum=3, aux=33), grad = (nothing,))

  m = TwoThirds([1.0], [2.0], [3.0])  # only the first should be tracked, but all should survive
  g = withgradient(m -> only(m.a::AbstractVector + m.b::Vector + m.c::Vector), m)
  @test g == (val = 6.0, grad = ((a = [1.0], b = nothing, c = nothing),))
end

using NNlib
@testset "NNlib.within_gradient" begin
  f_good(x) = NNlib.within_gradient(x) ? 10x : x
  @test gradient(f_good, 1.0)[1] == 10
  @test gradient(x -> sum(f_good(x)), [1.0])[1] == [10]
end

end  # overall @testset

using Tracker, Test, NNlib
using Tracker: TrackedReal, gradient, gradcheck, grad, checkpoint, forwarddiff
using NNlib: conv, ∇conv_data, depthwiseconv
using PDMats
using SpecialFunctions: logabsgamma
using Printf: @sprintf
using LinearAlgebra: diagm, dot, LowerTriangular, norm, det, logdet, logabsdet, I, Diagonal
using Statistics: mean, std, var
using Random
# using StatsBase

gradtest(f, xs::AbstractArray...; kw...) = gradcheck((xs...) -> sum(sin.(f(xs...))), xs...; kw...)
gradtest(f, dims...; kw...) = gradtest(f, rand.(Float64, dims)...; kw...)

@testset "gradtests 1" begin

@test gradtest((x, W, b) -> σ.(W*x .+ b), 5, (2,5), 2)
@test gradtest((x, W) -> σ.(W*x), 5, (2,5))
@test gradtest((x, W, b) -> σ.(W*x .+ b), (5,3), (2,5), 2)
@test gradtest((x, W, b) -> logσ.(W*x .+ b), 5, (2,5), 2)
@test gradtest((x, W, b) -> logσ.(W*x .+ b), (5,3), (2,5), 2)
@test gradtest((w, x) -> w'*x, randn(Float64,10, 2), randn(Float64,10))
@test gradtest((w, x) -> w*x', randn(Float64,5,5), randn(Float64,5,5))
let A=Diagonal(randn(5, 5))
    @test gradtest(x-> A * x, (5,))
    @test gradtest(x-> A * x, (5, 5))
    @test gradtest(x-> x * A, (5, 5))
end
@test gradtest(x -> sum(x, dims = (2, 3)), (3,4,5))
@test gradtest(x -> sum(x, dims = 1), randn(Float64,2,3))
@test gradtest(x -> sum(x, dims = [1,2]), randn(Float64,2,3))
@test gradtest(x -> sum(x), randn(Float64,2,3))
@test gradtest(x -> prod(x, dims=(2, 3)), (3,4,5))
@test gradtest(x -> prod(x), (3,4,5))

@test gradtest(x -> softmax(x; dims = 1).*(1:3), 3)
@test gradtest(x -> softmax(x; dims = 1).*(1:3), (3,5))
@test gradtest(x -> softmax(x; dims = 2).*(1:3), (3,5))
@test gradtest(x -> logsoftmax(x; dims = 1).*(1:3), 3)
@test gradtest(x -> logsoftmax(x; dims = 1).*(1:3), (3,5))
@test gradtest(x -> logsoftmax(x; dims = 2).*(1:3), (3,5))

RNG = NNlib.Random.MersenneTwister(1)
@test gradtest(x -> dropout(copy(RNG), x, 0.5), 10)
@test gradtest(x -> dropout(copy(RNG), x, 0.4; dims=1), (8, 9))

@test gradtest(x -> x', rand(5))

@test gradtest(det, (4, 4))
@test gradtest(logdet, map((x) -> x*x', (rand(4, 4),))[1])
@test gradtest((x) -> logabsdet(x)[1], (4, 4))

end # @testset gradtests

@testset "zero" begin
  @test zero(TrackedArray(rand(2))) isa TrackedArray
  @test gradtest(x-> zero(x) .* x, (2,))
end

@testset "indexing & slicing" begin
  @test gradtest(x->view(x, 1:2, 1:2), rand(4, 4))
end

function promotiontest(f, A, B, C)
  r0 = f(A, B, C)
  r1 = f(param(A), B, C)
  r2 = f(A, param(B), C)
  # r3 = f(A, B, param(C))  # no longer cater to tracked array in 3rd position
  r4 = f(param(A), param(B), param(C))

  @test !isa(r0, TrackedArray)
  # @test all(isa.([r1,r2,r3,r4], TrackedArray))
  # @test r1 == r2 == r3 == r4
  @test all(isa.([r1,r2,r4], TrackedArray))
  @test r1 == r2 == r4
  @test r0 == Tracker.data(r4)
end

@testset "concat" begin
  cat1(x...) = cat(x..., dims = 1)
  cat2(x...) = cat(x..., dims = 2)
  rvcat(x...) = reduce(vcat, x)
  rhcat(x...) = reduce(hcat, x)

  @testset "2-arg $vcatf" for vcatf in [vcat, cat1, rvcat]
    @test gradtest(vcatf, rand(5), rand(3))
    @test gradtest(vcatf, rand(5), rand(3), rand(8))
    @test gradtest(vcatf, rand(5)', rand(5)')
    @test gradtest(vcatf, rand(5,2), rand(3,2), rand(8,2))
    @test gradtest(vcatf, rand(5,2,3), rand(3,2,3), rand(8,2,3))
    @test gradtest(vcatf, rand(5), rand(3,1))
    @test gradtest(vcatf, rand(5)', rand(2,5))
  end


  @testset "2-arg $hcatf" for hcatf in [hcat, cat2, rhcat]
    @test gradtest(hcatf, rand(5), rand(5))
    @test gradtest(hcatf, rand(5)', rand(5)')
    @test gradtest(hcatf, rand(2,5), rand(2,3), rand(2,8))
    @test gradtest(hcatf, rand(2,5,3), rand(2,3,3), rand(2,8,3))
    @test gradtest(hcatf, rand(5), rand(5), rand(5,2))
    @test gradtest(hcatf, rand(5)', rand(1,3))
    @test gradtest(hcatf, rand(5), rand(5,2))
  end

  @testset "1-arg $catf" for catf in [vcat, cat1, rvcat, hcat, cat2, rhcat, (x...) -> cat(x..., dims = 3), (x...) -> cat(x..., dims = (1,2))]
    @test gradtest(catf, rand(5))
    @test gradtest(catf, rand(5)')
    @test gradtest(catf, rand(2,5))
    @test gradtest(catf, rand(2,5,3))
  end

  @test gradtest((x...) -> cat(x..., dims = 3), rand(2,5,2), rand(2,5,3), rand(2,5,4))

  @testset "cat($dim, ...)" for dim in 3:5
    catdim = (x...) -> cat(x..., dims = dim)
    @test gradtest(catdim, rand(5), rand(5), rand(5))
    @test gradtest(catdim, rand(2,5), rand(2,5), rand(2,5))
    @test gradtest(catdim, rand(2,5,3), rand(2,5,3), rand(2,5,3))
    dim == 3 && @test gradtest(catdim, rand(2,5,3), rand(2,5,0), rand(2,5,3))
  end

  @test !isa(vcat(rand(2)), TrackedArray)
  @test !isa(hcat(rand(2)), TrackedArray)
  @test !isa(cat(rand(2), dims=1), TrackedArray)

  @test gradtest((a,b)->cat(a, b, dims = (2,3,5)), rand(2,3), rand(2,4,2,1))

  @testset "promotiontest" begin
    @testset for fcat in [hcat, vcat, (x...) -> cat(x..., dims = 3), (x...) -> cat(x..., dims = (1,2))]
      promotiontest(fcat, rand(2), rand(2), rand(2))
      promotiontest(fcat, rand(2)', rand(2)', rand(2)')
      promotiontest(fcat, rand(2,2), rand(2,2), rand(2,2))
      promotiontest(fcat, rand(2,2,2), rand(2,2,2), rand(2,2,2))
    end

    promotiontest(vcat, rand(1,2), rand(2)', rand(2,2))
    promotiontest(hcat, rand(2,1), rand(2), rand(2,2))
    promotiontest(vcat, rand(3,4,5), rand(1,4,5), rand(2,4,5))
    promotiontest(hcat, rand(4,3,5), rand(4,1,5), rand(4,2,5))
    promotiontest((x...) -> cat(x..., dims = 3), rand(4,5,3), rand(4,5,1), rand(4,5,2))
  end

  @testset "scalars" begin
    @test vcat(param([1, 2, 3]), 1) isa TrackedArray
    @test vcat(1, param([1, 2, 3])) isa TrackedArray
    @test hcat(1, param([1 2 3;])) isa TrackedArray
    @test vcat(param(1), 2) isa TrackedArray
  end

  @testset "ambiguities" begin
    @test vcat(param([1, 2, 3]), [2,3]) isa TrackedArray
    @test vcat(param([1, 2, 3]), [2.0, 3.0]) isa TrackedArray
    @test hcat(param([1 2 3]), [2, 3]') isa TrackedArray
    @test hcat(param([1 2 3]), [2.0, 3.0]') isa TrackedArray
  end

end

@testset "getindex (Nabla.jl - #139)" begin
  z = [2, 3, 3]
  @test gradtest(x->x[z], randn(MersenneTwister(123456), 3))
end

@testset "gradtests 2" begin

@test gradtest(x -> permutedims(x, [3,1,2]), rand(4,5,6))
@test gradtest(x -> PermutedDimsArray(x, [3,1,2]), rand(4,5,6))

@test gradtest(reverse, rand(5))
@test gradtest(x -> reverse(x, dims=2), rand(4,5,6))
@test gradtest(x -> reverse(x, 2, 4), rand(5))

@test gradtest(x -> repeat(x; inner=2), rand(5))
@test gradtest(x -> repeat(x; inner=2, outer=3), rand(5))
@test gradtest(x -> repeat(x; inner=(2,2,1), outer=(1,1,3)), rand(5,4,3))

@test gradtest(kron, rand(5), rand(3))
@test gradtest(kron, rand(5), rand(3), rand(8))
@test gradtest(kron, rand(5,1), rand(3,1))
@test gradtest(kron, rand(5,1), rand(3,1), rand(8,1))
@test gradtest(kron, rand(5,2), rand(3,2), rand(8,2))

@test gradtest(x -> diagm(0 => x), rand(3))
@test gradtest(x -> Matrix(Diagonal(x)), rand(3))

@test gradtest(W -> inv(log.(W * W)), (5,5))
@test gradtest((A, B) -> A / B , (1,5), (5,5))
@test gradtest((A, B) -> log.(A * A) / exp.(B * B), (5,5), (5,5))
@test gradtest((A, B) -> A \ B, (5, 5), (5,))
@test let A=rand(5, 5)
    gradtest(B -> A \ B, (5,))
end
@test let B=rand(5,)
    gradtest(A -> A \ B, (5, 5))
end
@test gradtest((A, B) -> log.(A * A) \ exp.(B * B), (5,5), (5,5))
@test let A=rand(5, 5)
    gradtest(B -> log.(A * A) \ exp.(B * B), (5, 5))
end
@test let B=rand(5, 5)
    gradtest(A -> log.(A * A) \ exp.(B * B), (5, 5))
end

end  # @testset "gradtests 2"

@testset "mean" begin
  @test gradtest(mean, rand(2, 3))

  @test gradtest(x -> mean(x, dims=1), rand(2, 3))
  @test gradtest(x -> mean(x, dims=2), rand(2, 3))
  @test gradtest(x -> mean(x, dims=3), rand(2, 3, 4))

  @test gradtest(x -> mean(x, dims=[1, 2]), rand(2, 3, 4))
end

@testset "maximum" begin
  @test gradtest(maximum, rand(2, 3))

  @test gradtest(x -> maximum(x, dims=1), rand(2, 3))
  @test gradtest(x -> maximum(x, dims=2), rand(2, 3))
  @test gradtest(x -> maximum(x, dims=3), rand(2, 3, 4))

  @test gradtest(x -> maximum(x, dims=[1, 2]), rand(2, 3, 4))
end

@testset "minimum" begin
  @test gradtest(minimum, rand(2, 3))

  @test gradtest(x -> minimum(x, dims=1), rand(2, 3))
  @test gradtest(x -> minimum(x, dims=2), rand(2, 3))
  @test gradtest(x -> minimum(x, dims=3), rand(2, 3, 4))

  @test gradtest(x -> minimum(x, dims=[1, 2]), rand(2, 3, 4))
end

@testset "gradtests 3" begin

@test gradtest(x -> std(x), rand(5,5))
@test gradtest(x -> std(x, dims = 1), rand(5,5))
@test gradtest(x -> std(x, dims = 1, corrected = false), rand(5,5))

@test gradtest(x -> var(x), rand(5,5))
@test gradtest(x -> var(x, dims = 1), rand(5,5))
@test gradtest(x -> var(x, dims = 1, corrected = false), rand(5,5))
x55 = rand(5,5)
@test gradtest(x -> var(x, dims = 2, mean = mean(x55; dims=2)), x55)

@test gradtest((x, y) -> x .* y, rand(5), rand(5))
@test gradtest(dot, rand(5), rand(5))

@test gradtest(norm, rand(5))
@test gradtest(norm, zeros(5))
@test norm(TrackedArray(rand(Float32, 5))) isa TrackedReal{Float32}

@test gradtest(rand(5)) do x
  y = x.^2
  2y + x
end

end # @testset "gradtests 3"

@testset "transpose" begin
  w = Tracker.TrackedArray(rand(5,5))
  x = Tracker.TrackedArray(rand(5,5))
  @test w*x   isa TrackedArray
  @test w'*x  isa TrackedArray
  @test transpose(w)*x  isa TrackedArray
  @test w*x'  isa TrackedArray
  @test w*transpose(x)  isa TrackedArray
  @test w'*x' isa TrackedArray
  @test transpose(w)*transpose(x) isa TrackedArray

  x = Tracker.TrackedArray(rand(5))
  @test w*x   isa TrackedArray
  @test w'*x  isa TrackedArray
  @test transpose(w)*x  isa TrackedArray
  w = Tracker.TrackedArray(rand(5))
  x = Tracker.TrackedArray(rand(5))
  @test w*x'  isa TrackedArray
  @test w*transpose(x)  isa TrackedArray
  w = Tracker.TrackedArray(rand(5))
  x = Tracker.TrackedArray(rand(5,5))
  @test w'*x  isa TrackedArray
  @test transpose(w)*x  isa TrackedArray
  @test w'*x' isa TrackedArray
  @test transpose(w)*transpose(x) isa TrackedArray

  w = Tracker.TrackedArray(rand(5,5))
  x = rand(5,5)
  @test w*x   isa TrackedArray
  @test w'*x  isa TrackedArray
  @test transpose(w)*x  isa TrackedArray
  @test w*x'  isa TrackedArray
  @test w*transpose(x)  isa TrackedArray
  @test w'*x' isa TrackedArray
  @test transpose(w)*transpose(x) isa TrackedArray
  x = rand(5)
  @test w*x   isa TrackedArray
  @test w'*x  isa TrackedArray
  @test transpose(w)*x  isa TrackedArray
  w = Tracker.TrackedArray(rand(5))
  x = rand(5)
  @test w*x'  isa TrackedArray
  @test w*transpose(x)  isa TrackedArray
  w = Tracker.TrackedArray(rand(5))
  x = rand(5,5)
  @test w'*x  isa TrackedArray
  @test transpose(w)*x  isa TrackedArray
  @test w'*x' isa TrackedArray
  @test transpose(w)*transpose(x) isa TrackedArray

  w = rand(5,5)
  x = Tracker.TrackedArray(rand(5,5))
  @test w*x   isa TrackedArray
  @test w'*x  isa TrackedArray
  @test transpose(w)*x  isa TrackedArray
  @test w*x'  isa TrackedArray
  @test w*transpose(x)  isa TrackedArray
  @test w'*x' isa TrackedArray
  @test transpose(w)*transpose(x) isa TrackedArray
  x = Tracker.TrackedArray(rand(5))
  @test w*x   isa TrackedArray
  @test w'*x  isa TrackedArray
  @test transpose(w)*x  isa TrackedArray
  w = rand(5)
  x = Tracker.TrackedArray(rand(5))
  @test w*x'  isa TrackedArray
  @test w*transpose(x)  isa TrackedArray
  w = rand(5)
  x = Tracker.TrackedArray(rand(5,5))
  @test w'*x  isa TrackedArray
  @test transpose(w)*x  isa TrackedArray
  @test w'*x' isa TrackedArray
  @test transpose(w)*transpose(x) isa TrackedArray
end

@testset "conv, $(spatial_rank)d" for spatial_rank in (1, 2, 3)
    x = rand(repeat([10], spatial_rank)..., 3, 2)
    w = rand(repeat([3], spatial_rank)..., 3, 3)
    cdims = DenseConvDims(x, w)
    @test gradtest((x, w) -> conv(x, w, cdims), x, w)
    y = conv(x, w, cdims)
    @test gradtest((y, w) -> ∇conv_data(y, w, cdims), y, w)
    dcdims = DepthwiseConvDims(x, w)
    @test_skip gradtest((x, w) -> depthwiseconv(x, w, dcdims), x, w)
end

@testset "pooling" begin
  for spatial_rank in (1, 2)
    x = rand(repeat([10], spatial_rank)..., 3, 2)
    pdims = PoolDims(x, 2)
    @test gradtest(x -> maxpool(x, pdims), x)
    @test gradtest(x -> meanpool(x, pdims), x)
  end
end

# Upstream issue: https://github.com/JuliaDiff/ForwardDiff.jl/pull/538
@test_broken gradtest(x -> Float64.(x), 5)

@testset "equality & order" begin
    # TrackedReal
    @test param(2)^2 == param(4)
    @test param(2)^2 == 4
    @test 4 == param(2)^2

    @test param(2)^2 ≈ param(4)
    @test param(2)^2 ≈ 4
    @test 4 ≈ param(2)^2

    @test (param([1,2,3]) .< 2) == [true, false, false]
    @test (param([1,2,3]) .<= 2) == [true, true, false]
    @test (2 .> param([1,2,3])) == [true, false, false]
    @test (2 .>= param([1,2,3])) == [true, true, false]

    # TrackedArray
    @test param([1,2,3]).^2 == param([1,4,9])
    @test [1,2,3].^2 == param([1,4,9])
    @test param([1,2,3]).^2 == [1,4,9]

    @test param([1,2,3]).^2 ≈ param([1,4,9])
    @test [1,2,3].^2 ≈ param([1,4,9])
    @test param([1,2,3]).^2 ≈ [1,4,9]
end

@testset "reshape" begin
  x = reshape(param(rand(2,2,2)), 4, 2)
  @test x isa TrackedArray
  @test size(x) == (4,2)
  x = reshape(param([1]), (1,:))
  @test x isa TrackedArray
  @test size(x) == (1,1)
  x = reshape(param(rand(2)), (2,:))
  @test x isa TrackedArray
  @test size(x) == (2,1)
  x = reshape(param(rand(2,2)), (1,:,2))
  @test x isa TrackedArray
  @test size(x) == (1,2,2)
end

@testset "Intermediates" begin
  x = param([1])
  l = sum((x .+ x).^2)
  Tracker.back!(l, once = false)
  @test x.grad == [8]
  x.grad .= 0
  Tracker.back!(l, once = false)
  @test x.grad == [8]
end

@testset "Fallbacks" begin
  xs = param([1 2; 3 4])
  @test similar(xs) isa Matrix{Float64}
end

@test @sprintf("%.2f", sum(param([1,2,3]))) == "6.00"

# This no longer infers cleanly :(
#@inferred NNlib.conv(param(rand(10,10,3,2)), randn(Float64,2,2,3,4), DenseConvDims((10,10,3,2),(2,2,3,4)))

b = param(rand())
Tracker.back!(b)
@test Tracker.grad(b) == 1

@testset "collect" begin
  x, y = param(2), param(3)
  xy = Tracker.collect([x, y])
  @test xy isa TrackedArray{Float64}
  z = xy[1]*xy[2]
  back!(z)
  @test grad.((x,y)) == (3, 2)

  @test gradient(2, 3) do x, y
    xy = Tracker.collect([x, y])
    xy[1]*xy[2]
  end == (3, 2)

  gradient(x -> sum(Tracker.collect(x)), [1, 2, 3])[1] == [1, 1, 1]
end

# Gradient Hooks
@testset "Hooks" begin
  x = param(2)
  y = Tracker.hook(-, x)
  back!(y)
  @test grad(x) == -1
end

@testset "Checkpointing" begin
  count = 0
  function mul(a, b)
    count += 1
    a * b
  end
  @test gradient(x -> mul(5, x), 3)[1] == 5
  @test count == 1
  @test gradient(x -> checkpoint(mul, 5, x), 3)[1] == 5
  @test count == 3
end

@testset "Updates" begin
  xs = param([1, 2, 3])
  Tracker.update!(xs, param([4, 5, 6]))
  @test xs == [5, 7, 9]
  x = param(3)
  Tracker.update!(x, param(4))
  @test x == 7
end

@testset "Params" begin
  W = param(randn(5, 10))
  x = rand(10)
  dW = gradient(W -> sum(W*x), W)[1]
  gs = gradient(() -> sum(W*x), Tracker.Params([W]))
  @test gs[W] == dW
end

@testset "Forward" begin
  @test @inferred(Tracker.forward_jacobian(x -> [sum(x)], rand(5,5), Val(12)))[2] ==
    reshape(ones(25), :, 1)
  @test gradient([2, 3]) do x
    forwarddiff(x) do x
      x[1]*x[2]
    end
  end == ([3, 2],)
end

@testset "Custom Sensitivities" begin
  y, back = Tracker.forward(x -> [3x^2, 2x], 5)
  @test back([1, 1]) == (32,)
end

@testset "PDMats" begin
    B = rand(5, 5)
    S = PDMat(I + B * B')
    @test gradtest(A -> S / A, (5, 5))

    S = PDiagMat(rand(5))
    @test gradtest(A -> S / A, (5, 5))

    S = ScalMat(5, rand())
    @test gradtest(A -> S / A, (5, 5))
end


@testset "broadcast" begin
    f(x) = @. x < zero(x)
    y = @inferred(f(TrackedArray(rand(5, 3))))
    @test size(y) == (5, 3)
    @test !any(y)

    g(x) = @. (x < zero(x)) * x
    y = @inferred(g(TrackedArray(rand(5, 3))))
    @test size(y) == (5, 3)
end

@testset "logabsgamma" begin
  @test gradcheck(x -> logabsgamma(only(x))[1], rand(1))
  @test gradcheck(x -> logabsgamma(only(x))[2], rand(1))
end

@testset "rand" begin
  Random.seed!(1234)
  n_samples = 10^6
  x = [Random.rand(Tracker.TrackedReal{Float64}) for i in 1:n_samples]
  @test isapprox(mean(x), 0.5, atol=1e-2, rtol=0)
  @test isapprox(var(x), 1/12, atol=1e-2, rtol=0)

  x = [Random.randn(Tracker.TrackedReal{Float64}) for i in 1:n_samples]
  @test isapprox(mean(x), 0., atol=1e-2, rtol=0)
  @test isapprox(var(x), 1., atol=1e-2, rtol=0)

  x = [Random.randexp(Tracker.TrackedReal{Float64}) for i in 1:n_samples]
  @test isapprox(mean(x), 1., atol=1e-2, rtol=0)
  @test isapprox(var(x), 1., atol=1e-2, rtol=0)
end

module Tracker

using MacroTools
using MacroTools: @q, @forward

using DiffRules
using ForwardDiff
import ChainRulesCore as CRC
import LogExpFunctions
import NaNMath
import SpecialFunctions

import Printf

import Base: ==

export TrackedArray, TrackedVector, TrackedMatrix, Params, gradient,
  jacobian, hessian, param, back!, withgradient

tracker(x) = nothing

istracked(x) = tracker(x) ≠ nothing
isleaf(x) = !istracked(x) || isleaf(tracker(x))
grad(x) = grad(tracker(x))
grad(::Nothing) = nothing
data(x) = x

struct Call{F,As<:Tuple}
  func::F
  args::As
end

Call(f::F, args::T) where {F,T} = Call{F,T}(f, args)
Call() = Call(nothing, ())

# When deserialising, the object_id changes
a::Call == b::Call = a.func == b.func && a.args == b.args

@inline (c::Call)() = c.func(data.(c.args)...)

mutable struct Tracked{T}
  ref::UInt32
  f::Call
  isleaf::Bool
  grad::T
  Tracked{T}(f::Call) where T = new(0, f, false)
  Tracked{T}(f::Call, grad::T) where T = new(0, f, false, grad)
  Tracked{T}(f::Call{Nothing}, grad::T) where T = new(0, f, true, grad)
end

istracked(x::Tracked) = true
isleaf(x::Tracked) = x.f == Call()
grad(x::Tracked) = x.grad

track(f::Call, x) = Tracked{typeof(x)}(f)

function _forward end

function track(f::F, xs...; kw...) where F
  y, back = _forward(f, xs...; kw...)
  track(Call(back, tracker.(xs)), y)
end

macro grad(ex)
  @capture(shortdef(ex), (name_(args__) = body_) |
                         (name_(args__) where {T__} = body_)) || error("Need a function definition")
  T == nothing && (T = [])
  isexpr(name, :(::)) || (name = :(::typeof($name)))
  insert!(args, 1+isexpr(args[1], :parameters) , name)
  @q(Tracker._forward($(args...)) where $(T...) = $body) |> esc
end

include("idset.jl")
include("params.jl")
include("macros.jl")
include("lib/real.jl")
include("lib/array.jl")
include("back.jl")
include("numeric.jl")
include("forward.jl")

if !isdefined(Base, :get_extension)
  using Requires
end

@static if !isdefined(Base, :get_extension)
function __init__()
  @require PDMats="90014a1f-27ba-587c-ab20-58faa44d9150" include("../ext/TrackerPDMatsExt.jl")
end
end


"""
    hook(f, x) -> x′

Hook into gradient backpropagation. `x` is unmodified, but when backpropagating
`f` will be applied to the incoming gradient. For example, `hook(-, x)` will reverse
the sign of the gradient applied to `x`.
"""
hook(f, x) = istracked(x) ? track(hook, f, x) : x
@grad hook(f, x) = data(x), Δ -> (nothing, f(Δ))

"""
    checkpoint(f, args...)

Behaves like `f(args...)`, but avoids storing the intermediate values needed for
calculating gradients. Instead, `f(args...)` will be called again during the
backward pass. This can be used to save memory in larger models.
"""
checkpoint(f, args...) = track(checkpoint, f, args...)

@grad function checkpoint(f, args...)
  data(f(args...)), function (Δ)
    y, back = forward(f, args...)
    (nothing, back(Δ)...)
  end
end

nobacksies(f, x) = track(nobacksies, f, x)
nobacksies(f, xs::Tuple) = map(x -> nobacksies(f, x), xs)
@grad nobacksies(f::Symbol, x) = data(x), Δ -> error("Nested AD not defined for $f")
@grad nobacksies(f::String, x) = data(x), Δ -> error(f)

param(x::Number) = TrackedReal(float(x))
param(xs::AbstractArray) = TrackedArray(float.(xs))

@grad identity(x) = data(x), Δ -> (Δ,)
param(x::TrackedReal) = track(identity, x)
param(x::TrackedArray) = track(identity, x)

import Adapt: adapt, adapt_structure

adapt_structure(T, xs::TrackedArray) = param(adapt(T, data(xs)))

end

import Base: *, reduce

import LinearAlgebra
import LinearAlgebra: inv, det, logdet, logabsdet, \, /

using Statistics
using LinearAlgebra: Diagonal, Transpose, Adjoint, diagm, diag

struct TrackedArray{T,N,A<:AbstractArray{T,N}} <: AbstractArray{T,N}
  tracker::Tracked{A}
  data::A
  grad::A
  TrackedArray{T,N,A}(t::Tracked{A}, data::A) where {T,N,A} = new(t, data)
  TrackedArray{T,N,A}(t::Tracked{A}, data::A, grad::A) where {T,N,A} = new(t, data, grad)
end

data(x::TrackedArray) = x.data
tracker(x::TrackedArray) = x.tracker

TrackedVector{T,A} = TrackedArray{T,1,A}
TrackedMatrix{T,A} = TrackedArray{T,2,A}
TrackedVecOrMat{T,A} = Union{TrackedVector{T,A},TrackedMatrix{T,A}}

track(c::Call, x::AbstractArray) = TrackedArray(c, x)

TrackedArray(c::Call, x::A) where A <: AbstractArray =
  TrackedArray{eltype(A),ndims(A),A}(Tracked{A}(c), x)

TrackedArray(c::Call, x::A, Δ::A) where A <: AbstractArray =
  TrackedArray{eltype(A),ndims(A),A}(Tracked{A}(c, Δ), x, Δ)

TrackedArray(x::AbstractArray) = TrackedArray(Call(), x, zero(x))

Base.eltype(x::Type{<:TrackedArray{T}}) where T <: Real = TrackedReal{T}

Base.convert(::Type{T}, x::S) where {T<:TrackedArray,S<:T} = x

Base.convert(::Type{AbstractArray{T}}, x::TrackedArray) where T = T.(x)
Base.convert(::Type{AbstractArray{T}}, x::TrackedArray{T}) where T = x  # solve an ambiguity

Base.convert(T::Type{<:TrackedArray}, x::TrackedArray) =
  error("Not implemented: convert $(typeof(x)) to $T")

Base.convert(::Type{<:TrackedArray{T,N,A}}, x::AbstractArray) where {T,N,A} =
  TrackedArray(convert(A, x))

function Base.summary(io::IO, x::TrackedArray)
  print(io, "Tracked ")
  summary(io, data(x))
end

Base.print_array(io::IO, x::TrackedArray) = Base.print_array(io, data(x))

function Base.show(io::IO, x::TrackedArray)
  show(io, data(x))
  print(io, " (tracked)")
end

Base.copy(x::TrackedArray) = x

collect(xs::TrackedArray) = xs

Base.setindex!(xs::TrackedArray, v, i...; kwargs...) =
  error("Can't differentiate `setindex!`")

back!(::TrackedArray) = error("Value is not scalar; use `back!(sum(x))` or `back!(x, Δ)`")

function update!(x::TrackedArray, Δ)
  x.data .+= data(Δ)
  tracker(x).grad .= 0
  return x
end

function update!(x::AbstractArray, Δ)
  x .+= data(Δ)
  return x
end

# Fallthrough methods

for f in :[Base.size, Base.ndims, Base.collect].args
  @eval @inline $f(x::TrackedArray, a...) = $f(data(x), a...)
end

Base.size(x::TrackedArray, i::Integer, j::Integer, is::Integer...) =
  size(data(x), i, j, is...)

Base.similar(x::TrackedArray, T::Type, dims::Dims) = similar(data(x), T, dims)

for op in [:(==), :≈]
    @eval Base.$op(x::TrackedArray, y::AbstractArray) = Base.$op(data(x), y)
    @eval Base.$op(x::AbstractArray, y::TrackedArray) = Base.$op(x, data(y))
    @eval Base.$op(x::TrackedArray, y::TrackedArray) = Base.$op(data(x), data(y))
end

# Array Stdlib

Base.getindex(xs::TrackedArray, i...; kwargs...) = track(getindex, xs, i...; kwargs...)

@grad function getindex(xs::AbstractArray, i...; kwargs...)
  getindex(data(xs), i...; kwargs...), function (Δ)
        Δ′ = zero(data(xs))
        setindex!(Δ′, data(Δ), i...; kwargs...)
        (nobacksies(:getindex, Δ′), map(_->nothing, i)...)
    end
end

@grad function getindex(xs::AbstractArray, i::Array...)
  data(xs)[i...], function (Δ)
    Δ′ = zero(data(xs))
    @views Δ′[i...] .+= data(Δ)
    (nobacksies(:getindex, Δ′), map(_->nothing, i)...)
  end
end

Base.view(x::TrackedArray, inds...; kwargs...) = track(Base.view, x, inds...; kwargs...)

@grad function view(x::AbstractArray, inds...; kwargs...)
    view(data(x), inds...; kwargs...), function (Δ)
        grad_output = zero(data(x))
        subgrad = view(grad_output, inds...; kwargs...)
        subgrad[:] = data(Δ)
        (nobacksies(:view, grad_output), map(_->nothing, inds)...)
    end
end

Base.:-(xs::TrackedArray) = track(-, xs)

@grad -(xs) = -data(xs), Δ -> (-Δ,)

Base.transpose(xs::TrackedArray) = track(transpose, xs)
Base.adjoint(xs::TrackedArray) = track(adjoint, xs)

@grad transpose(xs) = transpose(data(xs)), Δ -> (trim(xs, transpose(Δ)),)
@grad adjoint(xs) = data(xs)', Δ -> (trim(xs, Δ'),)

det(xs::TrackedArray) = track(det, xs)
@grad det(xs) = det(data(xs)), Δ -> (Δ * det(xs) * transpose(inv(xs)),)

logdet(xs::TrackedArray) = track(logdet, xs)
@grad logdet(xs) = logdet(data(xs)), Δ -> (Δ * transpose(inv(xs)),)

logabsdet(xs::TrackedArray) = track(logabsdet, xs)
@grad logabsdet(xs) = logabsdet(data(xs)), Δ -> (Δ[1] * transpose(inv(xs)),)

Base.repeat(xs::TrackedArray; kw...) = track(repeat, xs; kw...)
Base.zero(x::Tracker.TrackedArray) = TrackedArray(zero(x.data))

@grad function repeat(xs; inner=ntuple(x->1, ndims(xs)), outer=ntuple(x->1, ndims(xs)))
  repeat(data(xs), inner = inner, outer = outer), function (Δ)
    Δ′ = zero(data(xs))
    S = size(xs)

    # Loop through each element of Δ, calculate source dimensions, accumulate into Δ′
    for (dest_idx, val) in pairs(IndexCartesian(), data(Δ))
        # First, round dest_idx[dim] to nearest gridpoint defined by inner[dim], then
        # wrap around based on original size S.
        src_idx = [mod1(div(dest_idx[dim] - 1, inner[dim]) + 1, S[dim]) for dim in 1:length(S)]
        Δ′[src_idx...] += val
    end
    (nobacksies(:repeat, Δ′),)
  end
end

for (T, S) in [(:TrackedArray, :TrackedArray), (:TrackedArray, :AbstractArray), (:AbstractArray, :TrackedArray)]
  for op in (:vcat, :hcat)
    @eval Base.$(op)(A::$T, B::$S, Cs::AbstractArray...) = track($(op), A, B, Cs...)
    @eval Base.$(op)(A::$T, B::$S, Cs::TrackedArray...) = track($(op), A, B, Cs...)
    @eval Base.$(op)(A::$T{<:Number}, B::$S{<:Number}, Cs::AbstractArray{<:Number}...) = track($(op), A, B, Cs...)
    @eval Base.$(op)(A::$T{<:Number}, B::$S{<:Number}, Cs::TrackedArray{<:Number}...) = track($(op), A, B, Cs...)
    @eval Base.$(op)(A::$T, B::$S) = track($(op), A, B)
  end
end
for (T, S) in [(:TrackedVector, :TrackedVector), (:TrackedVector, :AbstractVector), (:AbstractVector, :TrackedVector)]
  for op in (:vcat, :hcat)
    @eval Base.$(op)(A::$T, B::$S, Cs::AbstractVector...) = track($(op), A, B, Cs...)
    @eval Base.$(op)(A::$T, B::$S, Cs::TrackedVector...) = track($(op), A, B, Cs...)
    @eval Base.$(op)(A::$T{<:Number}, B::$S{<:Number}, Cs::AbstractVector{<:Number}...) = track($(op), A, B, Cs...)
    @eval Base.$(op)(A::$T{<:Number}, B::$S{<:Number}, Cs::TrackedVector{<:Number}...) = track($(op), A, B, Cs...)
    @eval Base.$(op)(A::$T, B::$S) = track($(op), A, B)
  end
end
for (T, S) in [(:TrackedVecOrMat, :TrackedVecOrMat), (:TrackedVecOrMat, :AbstractVecOrMat), (:AbstractVecOrMat, :TrackedVecOrMat)]
  for op in (:vcat, :hcat)
    @eval Base.$(op)(A::$T, B::$S, Cs::AbstractVecOrMat...) = track($(op), A, B, Cs...)
    @eval Base.$(op)(A::$T, B::$S, Cs::TrackedVecOrMat...) = track($(op), A, B, Cs...)
    @eval Base.$(op)(A::$T{<:Number}, B::$S{<:Number}, Cs::AbstractVecOrMat{<:Number}...) = track($(op), A, B, Cs...)
    @eval Base.$(op)(A::$T{<:Number}, B::$S{<:Number}, Cs::TrackedVecOrMat{<:Number}...) = track($(op), A, B, Cs...)
    @eval Base.$(op)(A::$T, B::$S) = track($(op), A, B)
  end
end
for (T, S) in [(:TrackedArray, :Real), (:Real, :TrackedArray), (:TrackedArray, :TrackedArray)]
    @eval Base.vcat(A::$T, B::$S, Cs::Union{TrackedArray, AbstractArray, Real}...) = track(vcat, A, B, Cs...)
    @eval Base.hcat(A::$T, B::$S, Cs::Union{TrackedArray, AbstractArray, Real}...) = track(hcat, A, B, Cs...)
    if T == :Real || S == :Real
      @eval Base.vcat(A::$T, B::$S) = track(vcat, A, B)
      @eval Base.hcat(A::$T, B::$S) = track(hcat, A, B)
    end
end
for (T, S) in [(:TrackedReal, :Real), (:Real, :TrackedReal), (:TrackedReal, :TrackedReal)]
    @eval Base.vcat(A::$T, B::$S, Cs::Real...) = track(vcat, A, B, Cs...)
    @eval Base.hcat(A::$T, B::$S, Cs::Real...) = track(hcat, A, B, Cs...)
end

Base.vcat(A::TrackedArray) = track(vcat, A)
Base.hcat(A::TrackedArray) = track(hcat, A)

Base.vcat(A::TrackedReal) = track(vcat, A)
Base.hcat(A::TrackedReal) = track(hcat, A)

@grad function vcat(xs...)
  vcat(data.(xs)...), function (Δ)
    start = 0
    Δs = [begin
      x = map(_ -> :, size(xsi))
      i = isempty(x) ? x : Base.tail(x)
      d = Δ[start+1:start+size(xsi,1), i...]
      start += size(xsi, 1)
      d
    end for xsi in xs]
    return (Δs...,)
  end
end

@grad function hcat(xs...)
  hcat(data.(xs)...), function (Δ)
    start = 0
    Δs = [begin
      d = if ndims(xsi) == 1
        Δ[:, start+1]
      else
        i = map(_ -> :, size(xsi)) |> Base.tail |> Base.tail
        Δ[:, start+1:start+size(xsi,2), i...]
      end
      start += size(xsi, 2)
      d
    end for xsi in xs]
    return (Δs...,)
  end
end

for (T, S) in [(:TrackedArray, :TrackedArray), (:TrackedArray, :AbstractArray), (:AbstractArray, :TrackedArray)]
    @eval Base.cat(A::$T, B::$S, Cs::AbstractArray...; dims) = track(cat, A, B, Cs...; dims = dims)
end

Base.cat(A::TrackedArray; dims) = track(cat, A; dims = dims)

@grad function cat(Xs...; dims)
  cat(data.(Xs)..., dims = dims), function (Δ)
    start = ntuple(i -> 0, Val(ndims(Δ)))
    Δs = [begin
      dim_xs = 1:ndims(xs)
      till_xs = ntuple((i -> i in dims ? (i in dim_xs ? size(xs,i) : 1) : 0), Val(ndims(Δ)))
      xs_in_Δ = ntuple(i -> i in dims ? (start[i]+1:start[i]+till_xs[i]) : Colon(), Val(ndims(Δ)))
      d = reshape(Δ[xs_in_Δ...],size(xs))
      start = start .+ till_xs
      d
    end for xs in Xs]
    return (Δs...,)
  end
end

function ∇reduce(f::typeof(vcat), Δ, xs)
  start = 0
  Δs = [begin
    x = map(_ -> :, size(xsi))
    i = isempty(x) ? x : Base.tail(x)
    d = Δ[start+1:start+size(xsi,1), i...]
    start += size(xsi, 1)
    d
  end for xsi in xs]
  return Δs
end

function ∇reduce(f::typeof(hcat), Δ, xs)
  start = 0
  Δs = [begin
    d = if ndims(xsi) == 1
      Δ[:, start+1]
    else
      i = map(_ -> :, size(xsi)) |> Base.tail |> Base.tail
      Δ[:, start+1:start+size(xsi,2), i...]
    end
    start += size(xsi, 2)
    d
  end for xsi in xs]
  return Δs
end

for f in [:vcat, :hcat]
  @eval function reduce(::typeof($f), xs::Vector{<:TrackedArray})
    y = reduce($f, data.(xs))
    track(Call(reduce, ($f, xs)), y)
  end
end

function scan(c::Call{typeof(reduce)})
    foreach(scan, tracker.(c.args[2]))
end

function back_(c::Call{typeof(reduce)}, Δ, once)
  f, xs = c.args
  foreach((x, d) -> back(x, d, once), tracker.(xs), data.(∇reduce(f, Δ, xs)))
end

Base.reshape(xs::TrackedArray, dims::Union{Colon,Int}...) = reshape(xs, dims)
Base.reshape(xs::TrackedArray, dims::Tuple{Vararg{Union{Int,Colon}}}) = reshape(xs, Base._reshape_uncolon(xs, dims))
Base.reshape(xs::TrackedArray, dims::Tuple{Vararg{Int}}) = track(reshape, xs, dims)

@grad reshape(xs, dims) = reshape(data(xs), dims), Δ -> (reshape(Δ, size(xs)),nothing)

Base.permutedims(xs::TrackedArray, perm) = track(permutedims, xs, perm)
@grad permutedims(xs, perm) = permutedims(data(xs), perm), Δ -> (permutedims(Δ, invperm(perm)),nothing)

Base.PermutedDimsArray(xs::TrackedArray, perm) = track(PermutedDimsArray, xs, perm)
@grad PermutedDimsArray(xs, perm) = PermutedDimsArray(data(xs), perm), Δ -> (PermutedDimsArray(Δ, invperm(perm)),nothing)

Base.reverse(xs::TrackedArray; dims) = track(reverse, xs, dims = dims)
@grad reverse(xs; dims) = reverse(data(xs), dims = dims), Δ -> (reverse(Δ, dims = dims), nothing)
Base.reverse(xs::TrackedVector) = track(reverse, xs)
@grad reverse(xs::TrackedVector) = reverse(data(xs)), Δ -> (reverse(Δ),)
Base.reverse(xs::TrackedVector, start::Integer, stop::Integer) = track(reverse, xs, start, stop)
@grad reverse(xs, start, stop) = reverse(data(xs), start, stop), Δ -> (reverse(Δ, start, stop), nothing, nothing)

function _kron(mat1::AbstractMatrix,mat2::AbstractMatrix)
    m1, n1 = size(mat1)
    mat1_rsh = reshape(mat1,(1,m1,1,n1))

    m2, n2 = size(mat2)
    mat2_rsh = reshape(mat2,(m2,1,n2,1))

    return reshape(mat1_rsh.*mat2_rsh, (m1*m2,n1*n2))
end
_kron(a::AbstractVector, b::AbstractVector) = vec(_kron(reshape(a, :, 1), reshape(b, :, 1)))

Base.kron(a::TrackedVecOrMat, b::TrackedVecOrMat)  = _kron(a, b)
Base.kron(a::TrackedVecOrMat, b::AbstractVecOrMat) = _kron(a, b)
Base.kron(a::AbstractVecOrMat, b::TrackedVecOrMat) = _kron(a, b)


inv(A::TrackedArray) = Tracker.track(inv, A)
@grad function inv(A)
    return inv(Tracker.data(A)), function (Δ)
        Ainv = inv(A)
        ∇A = - Ainv' * Δ * Ainv'
        return (∇A, )
    end
end

#       (/) rdivide
A::TrackedArray     / B::TrackedArray     = Tracker.track(/, A, B)
A::AbstractVecOrMat / B::TrackedArray     = Tracker.track(/, A, B)
A::TrackedArray     / B::AbstractVecOrMat = Tracker.track(/, A, B)
@grad function Base.:/(A, B)
    return Tracker.data(A) / Tracker.data(B), function (Δ)
        ∇A = Δ / B'
        ∇B = - (A / B)' * ∇A
        return (∇A, ∇B)
    end
end

#       (\) ldivide  (left vec divide needs more work to resolve dispatch ambiguity)
A::TrackedArray     \ B::TrackedArray     = Tracker.track(\, A, B)
A::AbstractArray    \ B::TrackedArray     = Tracker.track(\, A, B)
A::TrackedArray     \ B::AbstractVecOrMat = Tracker.track(\, A, B)
A::AbstractMatrix   \ B::TrackedVecOrMat  = Tracker.track(\, A, B)
A::TrackedMatrix    \ B::TrackedVecOrMat  = Tracker.track(\, A, B)
@grad function Base.:\(A, B)
    return Tracker.data(A) \ Tracker.data(B), function (Δ)
        ∇B = A' \ Δ
        ∇A = - ∇B * (A \ B)'
        return (∇A, ∇B)
    end
end


# Reductions

Base.sum(xs::TrackedArray; dims = :) = track(sum, xs, dims = dims)
Base.sum(f::Union{Function,Type},xs::TrackedArray) = sum(f.(xs))

@grad sum(xs; dims = :) = sum(data(xs), dims = dims),
  Δ -> (zero(xs) .+ Δ, )

Base.prod(xs::TrackedArray; dims=:) = track(prod, xs; dims=dims)
Base.prod(f::Union{Function, Type}, xs::TrackedArray) = prod(f.(xs))

@grad function prod(xs; dims=:)
  p = prod(data(xs); dims=dims)
  p, Δ -> (p ./ xs .* Δ,)
end

Base.findfirst(xs::TrackedArray, args...) = findfirst(xs.data, args...)

import LinearAlgebra: dot

dot(xs::TrackedArray, ys::TrackedArray) = track(dot, xs, ys)
dot(xs::AbstractArray, ys::TrackedArray) = track(dot, xs, ys)
dot(xs::TrackedArray, ys::AbstractArray) = track(dot, xs, ys)

@grad dot(xs, ys) = dot(data(xs), data(ys)), Δ -> (Δ .* ys, Δ .* xs)

# Hacks to get std working
Statistics.std(x::TrackedArray; dims = :, mean = Statistics.mean(x, dims = dims), corrected::Bool = true) = _std(x,mean,dims,corrected)
_std(x::TrackedArray, mean, dims, corrected) = sqrt.(sum((x .- mean).^2, dims = dims) ./ (mapreduce(i -> size(x,i),*, dims) - corrected))
_std(x::TrackedArray, mean, ::Colon, corrected) = sqrt.(sum((x .- mean).^2) ./ (length(x) - corrected))

Statistics.var(x::TrackedArray; dims=:, mean=Statistics.mean(data(x); dims), corrected::Bool=true) =
  track(Statistics.var, x; dims, mean=data(mean), corrected)
# from https://github.com/JuliaDiff/ChainRules.jl/blob/main/src/rulesets/Statistics/statistics.jl
@grad function Statistics.var(x; dims, mean, corrected)
  y = Statistics.var(data(x); corrected, mean, dims)
  function variance_back(dy)
    dx = 2 .* dy .* (data(x) .- mean) ./ (_denom(x, dims) - corrected)
    (dx,)
  end
  y, variance_back
end
_denom(x, dims::Integer) = size(x, dims)
_denom(x, dims::Colon) = length(x)
_denom(x, dims) = prod(i->size(x, i), unique(dims), init=1)

LinearAlgebra.norm(x::TrackedArray{T}, p::Real = 2) where T =
  (sum(abs.(x).^p) + eps(T))^(oneunit(T) / p) # avoid d(sqrt(x))/dx == Inf at 0

Statistics.mean(xs::TrackedArray; dims = :) = track(mean, xs, dims = dims)

@grad mean(xs; dims = :) = mean(data(xs), dims=dims), Δ -> (_backmean(xs,Δ,dims),)
_backmean(xs, Δ, ::Colon) = zero(xs) .+ Δ ./ length(xs)
_backmean(xs, Δ, dims) = zero(xs) .+ Δ ./ mapreduce(i -> size(data(xs),i),*,dims)

Base.maximum(xs::TrackedArray; dims = :) = track(maximum, xs, dims = dims)
Base.minimum(xs::TrackedArray; dims = :) = track(minimum, xs, dims = dims)

@grad function maximum(xs; dims = dims)
  maximum(data(xs), dims = dims), function (Δ)
    Δ′ = zero(data(xs))
    _, i = findmax(data(xs), dims = dims)
    Δ′[i] = data(Δ)
    return (nobacksies(:maximum, Δ′),)
  end
end

@grad function minimum(xs;  dims = dims)
  minimum(data(xs),  dims = dims), function (Δ)
    Δ′ = zero(data(xs))
    _, i = findmin(data(xs),  dims = dims)
    Δ′[i] = data(Δ)
    return (nobacksies(:minimum, Δ′),)
  end
end

# BLAS

LinearAlgebra.diagm(x::Pair{<:Integer, <:TrackedVector}) = track(diagm, x...)
@grad diagm(i, x) = diagm(i => data(x)), Δ -> (nothing, diag(Δ, i))

# fix Matrix(Diagonal(param([1,2,3]))) after https://github.com/JuliaLang/julia/pull/44615
(::Type{Matrix})(d::Diagonal{<:Any,<:TrackedArray}) = diagm(0 => d.diag)

x::TrackedMatrix  * y::AbstractMatrix = track(*, x, y)
x::AbstractMatrix * y::TrackedMatrix  = track(*, x, y)
x::TrackedMatrix  * y::TrackedMatrix  = track(*, x, y)

x::TrackedMatrix  * y::AbstractVector = track(*, x, y)
x::AbstractMatrix * y::TrackedVector  = track(*, x, y)
x::TrackedMatrix  * y::TrackedVector  = track(*, x, y)

x::TrackedVector  * y::AbstractVector = track(*, x, y)
x::AbstractVector * y::TrackedVector  = track(*, x, y)
x::TrackedVector  * y::TrackedVector  = track(*, x, y)

# Ambiguity fixes
Base.:*(x::Transpose{T,<:AbstractVector{T}},y::TrackedMatrix) where {T} = track(*, x, y)
Base.:*(x::TrackedMatrix,y::Transpose{T,<:AbstractVector{T}}) where {T} = track(*, x, y)

Base.:*(x::Transpose{T,<:AbstractMatrix{T}},y::TrackedMatrix) where {T} = track(*, x, y)
Base.:*(x::TrackedMatrix,y::Transpose{T,<:AbstractMatrix{T}}) where {T} = track(*, x, y)

Base.:*(x::Transpose{T,<:AbstractVector{T}},y::TrackedVector) where {T} = track(*, x, y)
Base.:*(x::TrackedVector,y::Transpose{T,<:AbstractVector{T}}) where {T} = track(*, x, y)

Base.:*(x::Transpose{T,<:AbstractMatrix{T}},y::TrackedVector) where {T} = track(*, x, y)
Base.:*(x::TrackedVector,y::Transpose{T,<:AbstractMatrix{T}}) where {T} = track(*, x, y)

Base.:*(x::Adjoint{T,<:AbstractVector{T}},y::TrackedMatrix) where {T} = track(*, x, y)
Base.:*(x::TrackedMatrix,y::Adjoint{T,<:AbstractVector{T}}) where {T} = track(*, x, y)

Base.:*(x::Adjoint{T,<:AbstractMatrix{T}},y::TrackedMatrix) where {T} = track(*, x, y)
Base.:*(x::TrackedMatrix,y::Adjoint{T,<:AbstractMatrix{T}}) where {T} = track(*, x, y)

Base.:*(x::Adjoint{T,<:AbstractVector{T}},y::TrackedVector) where {T} = track(*, x, y)
Base.:*(x::TrackedVector,y::Adjoint{T,<:AbstractVector{T}}) where {T} = track(*, x, y)

Base.:*(x::Adjoint{T,<:AbstractMatrix{T}},y::TrackedVector) where {T} = track(*, x, y)
Base.:*(x::TrackedVector,y::Adjoint{T,<:AbstractMatrix{T}}) where {T} = track(*, x, y)

Base.:*(x::Diagonal, y::TrackedVector) = track(*, x, y)

Base.:*(x::Diagonal, y::TrackedMatrix) = track(*, x, y)
Base.:*(x::TrackedMatrix, y::Diagonal) = track(*, x, y)

@grad a::AbstractVecOrMat * b::AbstractVecOrMat =
  data(a)*data(b), Δ -> (Δ * transpose(b), transpose(a) * Δ)

# NNlib

using NNlib
import NNlib: softmax, ∇softmax, logsoftmax, ∇logsoftmax, conv, ∇conv_data, depthwiseconv, maxpool, meanpool
import NNlib: DenseConvDims, DepthwiseConvDims, PoolDims, within_gradient, dropout

within_gradient(::TrackedArray) = true
within_gradient(::TrackedReal) = true

softmax(xs::TrackedArray; dims=1) = track(softmax, xs; dims=dims)

if isdefined(NNlib, :∇softmax_data)  # use new form to avoid a depwarn, but only possible Julia 1.6+
  @eval @grad function softmax(xs; dims=1)
    y = softmax(data(xs); dims=dims)
    y, Δ -> (nobacksies(:softmax, NNlib.∇softmax_data(data(Δ), data(y); dims=dims)),)
  end
else
  @eval @grad function softmax(xs; dims=1)  # TODO delete this when dropping Julia 1.3 (and increase NNlib bound)
    y = softmax(data(xs); dims=dims)
    y, Δ -> (nobacksies(:softmax, ∇softmax(data(Δ), data(xs), data(y); dims=dims)),)
  end
end

logsoftmax(xs::TrackedArray; dims=1) = track(logsoftmax, xs; dims=dims)

if isdefined(NNlib, :∇logsoftmax_data)  # use new form to avoid a depwarn, but only possible Julia 1.6+
  @eval @grad function logsoftmax(xs; dims=1)
    y = logsoftmax(data(xs); dims=dims)
    y, Δ -> (nobacksies(:logsoftmax, NNlib.∇logsoftmax_data(data(Δ), data(y); dims=dims)),)
  end
else
  @eval @grad function logsoftmax(xs; dims=1)
    y = logsoftmax(data(xs); dims=dims)
    y, Δ -> (nobacksies(:logsoftmax, ∇logsoftmax(data(Δ), data(xs), data(y); dims=dims)),)
  end
end

dropout(rng::AbstractRNG, A::TrackedArray, p::Real; dims=:) = track(dropout, rng, A, p; 
dims)

@grad function dropout(rng::AbstractRNG, A::TrackedArray{T}, p::Real; dims = :) where T
    val = convert(T, 1/(1-p))
    keep = if dims isa Colon
        similar(A.data, T, size(A))
    else
        similar(A.data, T, ntuple(d -> d in dims ? size(A,d) : 1, ndims(A)))
    end
    rand!(rng, keep)
    Y = @. ((keep>p) * val) * A.data
    function dropout_back(Δ)
        dY = data(Δ)
        dA = @. ((keep>p) * val) * dY
        # (nothing, nobacksies(:dropout, dA), nothing)
        (nothing, dA, nothing)
    end
    return Y, dropout_back
end

for (xType, wType) in [(:TrackedArray, :TrackedArray), (:AbstractArray, :TrackedArray),
    (:TrackedArray, :AbstractArray)]
  @eval begin
    @grad_from_chainrules depthwiseconv(::$xType, ::$wType, ::DepthwiseConvDims; kw...)
    @grad_from_chainrules conv(::$xType, ::$wType, ::DenseConvDims; kw...)
    @grad_from_chainrules ∇conv_data(::$xType, ::$wType, ::DenseConvDims; kw...)
  end
end

@grad_from_chainrules maxpool(::TrackedArray, ::PoolDims; kw...)
@grad_from_chainrules meanpool(::TrackedArray, ::PoolDims; kw...)

# Broadcasting

using ForwardDiff: Dual, partials, value

trim(x, Δ) = reshape(Δ, ntuple(i -> size(Δ, i), Val(ndims(x))))

unbroadcast(x::AbstractArray, Δ) =
  size(x) == size(Δ) ? Δ :
  length(x) == length(Δ) ? trim(x, Δ) :
    trim(x, sum(Δ, dims = ntuple(i -> size(x, i) == 1 ? i : ndims(Δ)+1, Val(ndims(Δ)))))

unbroadcast(x::Number, Δ) = sum(Δ)
unbroadcast(x::Base.RefValue, _) = nothing

dual(x, p) = x
dual(x::Real, p) = Dual(x, p)

function partial(f::F, Δ, i, args::Vararg{Any,N}) where {F,N}
  dargs = ntuple(j -> dual(args[j], i==j), Val(N))
  return Δ * f(dargs...).partials[1]
end

@inline function ∇broadcast(f::F, args::Vararg{Any,N}) where {F,N}
  y = broadcast(f, data.(args)...)
  (eltype(y) <: Real && eltype(y) !== Bool) || return y
  function back(Δ)
    Δargs = ntuple(i -> partial.(f, Δ, i, args...), Val(N))
    dxs = map(unbroadcast, args, Δargs)
    return dxs
  end
  # So we can return non-tracked arrays
  track(Call(back, tracker.(args)), y)
end

using Base.Broadcast: BroadcastStyle, ArrayStyle, Broadcasted, broadcasted

struct TrackedStyle <: BroadcastStyle end

Broadcast.BroadcastStyle(::Type{<:Union{TrackedArray,TrackedReal}}) = TrackedStyle()
Broadcast.BroadcastStyle(::TrackedStyle, ::BroadcastStyle) = TrackedStyle()

# We have to re-build the original broadcast struct to get the appropriate array
# style. We need this primarily to support CuArrays' broadcasting fixes.
broadcast_rebuild(xs) = data(xs)

broadcast_rebuild(bc::Broadcasted) =
  Broadcasted(bc.f, map(broadcast_rebuild, bc.args))

preprocess(x) = x

function Base.copy(bc::Broadcasted{TrackedStyle})
  bc1 = Broadcast.flatten(bc)
  bc2 = Broadcast.flatten(broadcast_rebuild(bc))
  ∇broadcast(bc2.f, bc1.args...)
end

# https://github.com/FluxML/Flux.jl/issues/353
@inline function make_makeargs(makeargs, t::Tuple{<:Broadcasted,Vararg{Any}})
  bc = t[1]
  let makeargs = make_makeargs(makeargs, tail(t)), f = bc.f
    let makeargs = make_makeargs(makeargs, bc.args)
      headargs, tailargs = make_headargs(bc.args), make_tailargs(bc.args)
      return @inline function(args::Vararg{Any,N}) where N
        args1 = makeargs(args...)
        a, b = headargs(args1...), tailargs(args1...)
        (f(a...), b...)
      end
    end
  end
end

struct Params
  order::Vector{Any}
  params::IdSet{Any}
  Params() = new([], IdSet())
end

@forward Params.order Base.iterate, Base.length

function Base.push!(ps::Params, x)
  if !(x in ps.params)
    push!(ps.order, x)
    push!(ps.params, x)
  end
  return ps
end

Base.push!(ps::Params, x...) = (foreach(x -> push!(ps, x), x); ps)

Params(xs) = push!(Params(), xs...)

function Base.show(io::IO, ps::Params)
  print(io, "Params([")
  join(io, ps.order, ", ")
  print(io, "])")
end

struct Grads
  grads::IdDict{Any,Any}
end

Base.show(io::IO, ps::Grads) = println(io, "Grads(...)")

Grads() = Grads(IdDict())

@forward Grads.grads Base.setindex!, Base.haskey, Base.length, Base.iterate

Grads(ps::Params) = Grads(IdDict(tracker(p) => init_grad(data(p)) for p in ps))

Base.getindex(g::Grads, x::Tracked) = g.grads[x]

function Base.getindex(g::Grads, x)
  istracked(x) || error("Object not tracked: $x")
  g[tracker(x)]
end

accum!(g::Grads, x, Δ) = g[x] = haskey(g, x) ? g[x] .+ Δ : Δ

function ngradient(f, xs::AbstractArray...)
  grads = zero.(xs)
  for (x, Δ) in zip(xs, grads), i in 1:length(x)
    δ = sqrt(eps())
    tmp = x[i]
    x[i] = tmp - δ/2
    y1 = f(xs...)
    x[i] = tmp + δ/2
    y2 = f(xs...)
    x[i] = tmp
    Δ[i] = (y2-y1)/δ
  end
  return grads
end

gradcheck(f, xs...; rtol = 1e-5, atol = 1e-5) =
  all(isapprox.(ngradient(f, xs...),
                data.(gradient(f, xs...)); rtol = rtol, atol = atol))

using ForwardDiff

seed(x::Real, ::Val) = Dual(x, true)

function seed(x, ::Val{N}, offset = 0) where N
  map(x, reshape(1:length(x), size(x))) do x, i
    Dual(x, ntuple(j -> j+offset == i, Val(N)))
  end
end

extract(x::ForwardDiff.Dual) = x.value, [x.partials...]

function extract(xs::AbstractArray{ForwardDiff.Dual{T,V,N}}) where {T,V,N}
  J = similar(xs, V, N, length(xs))
  for i = 1:length(xs), j = 1:N
    J[j, i] = xs[i].partials.values[j]
  end
  return map(x -> x.value, xs), J
end

function forward_jacobian(f, x, ::Val{N}) where N
  y, _J = extract(f(seed(x, Val(N))))
  J = similar(_J, length(x), length(y))
  J[1:N,:] = _J
  offset = 0
  while offset + N < length(x)
    offset += N
    _, _J = extract(f(seed(x, Val(N), offset)))
    range = (1+offset):min(N+offset,length(x))
    J[range,:] = @view _J[range.-offset,:]
  end
  return y, J
end

function forward_jacobian(f, x)
  if length(x) < ForwardDiff.DEFAULT_CHUNK_THRESHOLD
    forward_jacobian(f, x, Val(length(x)))
  else
    forward_jacobian(f, x, Val(ForwardDiff.DEFAULT_CHUNK_THRESHOLD))
  end
end

forwarddiff(f, x) = istracked(x) ? track(forwarddiff, f, x) : f(x)

vec_scalar(x) = vec(x)
vec_scalar(x::Real) = [x]
reshape_scalar(x, y) = reshape(y, size(x))
reshape_scalar(x::Real, y) = y[]

@grad function forwarddiff(f, x)
  y, J = forward_jacobian(f, data(x))
  return y, ȳ -> (nothing, reshape_scalar(x, J*vec_scalar(ȳ)))
end

"""
    @grad_from_chainrules f(args...; kwargs...)

The `@grad_from_chainrules` macro provides a way to import adjoints(rrule) defined in
ChainRules to Tracker. One must provide a method signature to import the corresponding
rrule. In the provided method signature, one should replace the types of arguments to which
one wants to take derivatives with respect with Tracker.TrackedReal and Tracker.TrackedArray
respectively. For example, we can import rrule of `f(x::Real, y::Array)`` like below:

    Tracker.@grad_from_chainrules f(x::TrackedReal, y::TrackedArray)
    Tracker.@grad_from_chainrules f(x::TrackedReal, y::Array)
    Tracker.@grad_from_chainrules f(x::Real, y::TrackedArray)

Acceptable type annotations are `TrackedReal`, `TrackedArray`, `TrackedVector`, and
`TrackedMatrix`. These can have parameters like `TrackedArray{Float32}`.
"""
macro grad_from_chainrules(fcall)
  @assert isdefined(__module__, :Tracker) "Tracker not found in module $__module__. Please load `Tracker.jl`."
  Meta.isexpr(fcall, :call) && length(fcall.args) ≥ 2 ||
    error("`@grad_from_chainrules` has to be applied to a function signature")

  f = fcall.args[1]
  # Check if kwargs... splatting is present
  kws_var = Meta.isexpr(fcall.args[2], :parameters) ? fcall.args[2].args[1].args[1] :
            nothing
  rem_args = Meta.isexpr(fcall.args[2], :parameters) ? fcall.args[3:end] :
             fcall.args[2:end]
  xs = map(rem_args) do x
    Meta.isexpr(x, :(::)) || return x
    length(x.args) == 1 && return :($(gensym())::$(x.args[1])) # ::T without var name
    @assert length(x.args) == 2
    return :($(x.args[1])::$(x.args[2])) # x::T
  end
  xs_untyped = map(xs) do x
    Meta.isexpr(x, :(::)) || return x
    return x.args[1]
  end

  untrack_args = map(enumerate(xs)) do (i, x)
    Meta.isexpr(x, :(::)) || return (x, nothing)
    name, type = x.args
    type = __strip_type(type)
    type in (:TrackedArray, :TrackedVector, :TrackedMatrix, :TrackedReal) || return (name, nothing)
    xdata = gensym(name)
    return xdata, :($(xdata) = $(Tracker.data)($(name)))
  end
  untrack_calls = filter(Base.Fix2(!==, nothing), last.(untrack_args))
  @assert length(untrack_calls) > 0 "No tracked arguments found."
  var_names = first.(untrack_args)

  f_sym = Meta.quot(Symbol(f))

  if kws_var === nothing
    return esc(quote
      $(f)($(xs...)) = $(Tracker.track)($(f), $(xs_untyped...))
      function Tracker._forward(::typeof($(f)), $(xs...))
        $(untrack_calls...)
        y, pb_f = $(CRC.rrule)($(f), $(var_names...))
        ∇internal_generated = let pb_f = pb_f # Avoid Boxing
          Δ -> return Tracker.nobacksies($(f_sym), $(__no_crctangent).(pb_f($(data)(Δ))[2:end]))
        end
        return y, ∇internal_generated
      end
    end)
  end
  return esc(quote
    function $(f)($(xs...); $(kws_var)...)
      return Tracker.track($(f), $(xs_untyped...); $(kws_var)...)
    end
    function Tracker._forward(::typeof($(f)), $(xs...); $(kws_var)...)
      $(untrack_calls...)
      y, pb_f = $(CRC.rrule)($(f), $(var_names...); $(kws_var)...)
      ∇internal_generated = let pb_f = pb_f # Avoid Boxing
        Δ -> Tracker.nobacksies($(f_sym), $(__no_crctangent).(pb_f($(data)(Δ))[2:end]))
      end
      return y, ∇internal_generated
    end
  end)
end

@inline __no_crctangent(::CRC.NoTangent) = nothing
@inline __no_crctangent(::CRC.ZeroTangent) = nothing
@inline __no_crctangent(x::CRC.AbstractThunk) = CRC.unthunk(x)
@inline __no_crctangent(x) = x

@inline function __strip_type(type)
  Meta.isexpr(type, :curly) && (type = type.args[1]) # Strip parameters from types
  Meta.isexpr(type, :(.)) && (type = type.args[2]) # Strip Tracker from Tracker.<...> 
  type isa QuoteNode && (type = type.value) # Unwrap a QuoteNode
  return type
end

struct IdSet{T} <: AbstractSet{T}
  dict::IdDict{T,Nothing}
  IdSet{T}() where T = new(IdDict{T,Nothing}())
end

Base.eltype(::IdSet{T}) where T = T

IdSet() = IdSet{Any}()

Base.push!(s::IdSet) = s
Base.push!(s::IdSet{T}, x::T) where T = (s.dict[x] = nothing; s)
Base.delete!(s::IdSet{T}, x::T) where T = (delete!(s.dict, x); s)
Base.in(x, s::IdSet) = haskey(s.dict, x)

IdSet{T}(xs) where T = push!(IdSet{T}(), xs...)

IdSet(xs) = IdSet{eltype(xs)}(xs)

Base.collect(s::IdSet) = Base.collect(keys(s.dict))
Base.similar(s::IdSet, T::Type) = IdSet{T}()

@forward IdSet.dict Base.length

function Base.iterate(v::IdSet, state...)
  y = Base.iterate(keys(v.dict), state...)
  y === nothing && return nothing
  return (y[1], y[2])
end

# Adapted from https://github.com/JuliaDiff/Tracker.jl/blob/master/test/ChainRulesTests.jl
module ChainRulesTest  # Run in isolatex environment

using LinearAlgebra
using ChainRulesCore
using Tracker
using Test

struct MyStruct end
f(::MyStruct, x) = sum(4x .+ 1)
f(x, y::MyStruct) = sum(4x .+ 1)
f(x) = sum(4x .+ 1)

rrule_f_singleargs = Ref(0)
rrule_f_mystruct_x = Ref(0)
rrule_f_x_mystruct = Ref(0)

function ChainRulesCore.rrule(::typeof(f), x)
  rrule_f_singleargs[] += 1
  r = f(x)
  back(d) = NoTangent(), fill(4 * d, size(x))
  return r, back
end
function ChainRulesCore.rrule(::typeof(f), ::MyStruct, x)
  rrule_f_mystruct_x[] += 1
  r = f(MyStruct(), x)
  back(d) = NoTangent(), NoTangent(), fill(4 * d, size(x))
  return r, back
end
function ChainRulesCore.rrule(::typeof(f), x, ::MyStruct)
  rrule_f_x_mystruct[] += 1
  r = f(x, MyStruct())
  back(d) = NoTangent(), fill(4 * d, size(x)), NoTangent()
  return r, back
end

Tracker.@grad_from_chainrules f(x::Tracker.TrackedArray)
# test arg type hygiene
Tracker.@grad_from_chainrules f(::MyStruct, x::Tracker.TrackedArray)
Tracker.@grad_from_chainrules f(x::Tracker.TrackedArray, y::MyStruct)

g(x, y) = sum(4x .+ 4y)

rrule_g_x_y = Ref(0)

function ChainRulesCore.rrule(::typeof(g), x, y)
  rrule_g_x_y[] += 1
  r = g(x, y)
  back(d) = NoTangent(), fill(4 * d, size(x)), fill(4 * d, size(x))
  return r, back
end

Tracker.@grad_from_chainrules g(x::Tracker.TrackedArray, y)
Tracker.@grad_from_chainrules g(x, y::Tracker.TrackedArray)
Tracker.@grad_from_chainrules g(x::Tracker.TrackedArray, y::Tracker.TrackedArray)

@testset "rrule in ChainRules and Tracker" begin
  ## ChainRules
  # function f
  input = rand(3, 3)
  output, back = ChainRulesCore.rrule(f, input)
  _, d = back(1)
  @test output == f(input)
  @test d == fill(4, size(input))
  @test rrule_f_singleargs[] == 1
  # function g
  inputs = rand(3, 3), rand(3, 3)
  output, back = ChainRulesCore.rrule(g, inputs...)
  _, d1, d2 = back(1)
  @test output == g(inputs...)
  @test d1 == fill(4, size(inputs[1]))
  @test d2 == fill(4, size(inputs[2]))
  @test rrule_g_x_y[] == 1
end

@testset "custom struct input" begin
  input = rand(3, 3)
  output, back = ChainRulesCore.rrule(f, MyStruct(), input)
  _, _, d = back(1)
  @test output == f(MyStruct(), input)
  @test d == fill(4, size(input))
  @test rrule_f_mystruct_x[] == 1

  output, back = ChainRulesCore.rrule(f, input, MyStruct())
  _, d, _ = back(1)
  @test output == f(input, MyStruct())
  @test d == fill(4, size(input))
  @test rrule_f_x_mystruct[] == 1
end

### Functions with varargs and kwargs
# Varargs
f_vararg(x, args...) = sum(4x .+ sum(args))

rrule_f_vararg = Ref(0)

function ChainRulesCore.rrule(::typeof(f_vararg), x, args...)
  rrule_f_vararg[] += 1
  r = f_vararg(x, args...)
  back(d) = (NoTangent(), fill(4 * d, size(x)), ntuple(_ -> NoTangent(), length(args))...)
  return r, back
end

Tracker.@grad_from_chainrules f_vararg(x::Tracker.TrackedArray, args...)

@testset "Function with Varargs" begin
  grads = Tracker.gradient(x -> f_vararg(x, 1, 2, 3) + 2, rand(3, 3))

  @test grads[1] == fill(4, (3, 3))
  @test rrule_f_vararg[] == 1
end

# Vargs and kwargs
f_kw(x, args...; k=1, kwargs...) = sum(4x .+ sum(args) .+ (k + kwargs[:j]))

rrule_f_kw = Ref(0)

function ChainRulesCore.rrule(::typeof(f_kw), x, args...; k=1, kwargs...)
  rrule_f_kw[] += 1
  r = f_kw(x, args...; k=k, kwargs...)
  back(d) = (NoTangent(), fill(4 * d, size(x)), ntuple(_ -> NoTangent(), length(args))...)
  return r, back
end

Tracker.@grad_from_chainrules f_kw(x::Tracker.TrackedArray, args...; k=1, kwargs...)

@testset "Function with Varargs and kwargs" begin
  inputs = rand(3, 3)
  results = Tracker.gradient(x -> f_kw(x, 1, 2, 3; k=2, j=3) + 2, inputs)

  @test results[1] == fill(4, size(inputs))
  @test rrule_f_kw[] == 1
end

### Mix @grad and @grad_from_chainrules

h(x) = 10x
h(x::Tracker.TrackedArray) = Tracker.track(h, x)

grad_hcalls = Ref(0)

Tracker.@grad function h(x)
  grad_hcalls[] += 1
  xv = Tracker.data(x)
  return h(xv), Δ -> (Δ * 10,) # use 7 asits derivatives
end

@testset "Tracker and ChainRules Mixed" begin
  t(x) = g(x, h(x))
  inputs = rand(3, 3)
  results = Tracker.gradient(t, inputs)
  @test results[1] == fill(44, size(inputs)) # 44 = 4 + 4 * 10
  @test rrule_g_x_y[] == 2
  @test grad_hcalls[] == 1
end

### Isolated Scope
module IsolatedModuleForTestingScoping

using ChainRulesCore, Test
using Tracker: Tracker, @grad_from_chainrules

f(x) = sum(4x .+ 1)

rrule_f_singleargs = Ref(0)

function ChainRulesCore.rrule(::typeof(f), x)
  rrule_f_singleargs[] += 1
  r = f(x)
  back(d) = NoTangent(), fill(4 * d, size(x))
  return r, back
end

@grad_from_chainrules f(x::Tracker.TrackedArray)

module SubModule
using Test
using Tracker: Tracker
using ..IsolatedModuleForTestingScoping: f, rrule_f_singleargs

@testset "rrule in Isolated Scope" begin
  inputs = rand(3, 3)
  results = Tracker.gradient(x -> f(x) + 2, inputs)

  @test results[1] == fill(4, size(inputs))
  @test rrule_f_singleargs[] == 1
end

end # end of SubModule

end # end of IsolatedModuleForTestingScoping

end
